"""Пакет приложения msbackup."""

import os
import io
import re
import ast
import subprocess


# To use a consistent encoding
def read(*names, **kwargs):
    """Чтение текстового файла."""
    with io.open(
        os.path.join(*names),
        encoding=kwargs.get('encoding', 'utf-8'),
    ) as fp:
        return fp.read().rstrip()


__date__ = "2015-10-08"

here = os.path.abspath(os.path.dirname(__file__))
root = os.path.abspath(os.path.join(here, "..", ".."))

if not os.path.exists(os.path.join(root, "scripts", "version.sh")):
    root = os.path.abspath(os.path.join(root, "..", "..", "..", "..", ".."))

if os.path.exists(os.path.join(root, "scripts", "version.sh")):
    __version__ = subprocess.check_output(
        ["scripts/version.sh"],
        cwd=root,
    ).decode("utf-8").strip()
    __updated__ = subprocess.check_output(
        ["scripts/updated.sh"],
        cwd=root,
    ).decode("utf-8").strip()
else:
    meta = read(here, "meta.py")
    _version_re = re.compile(r'version\s+=\s+(.*)')
    __version__ = str(ast.literal_eval(_version_re.search(meta).group(1)))
    _updated_re = re.compile(r'updated\s+=\s+(.*)')
    __updated__ = str(ast.literal_eval(_updated_re.search(meta).group(1)))
